/* tslint:disable */
/* eslint-disable */
/**
 * NinjaAPI
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface IDirContentSchema
 */
export interface IDirContentSchema {
    /**
     * 
     * @type {string}
     * @memberof IDirContentSchema
     */
    'path': string;
    /**
     * 
     * @type {string}
     * @memberof IDirContentSchema
     */
    'name': string;
    /**
     * 
     * @type {boolean}
     * @memberof IDirContentSchema
     */
    'is_dir': boolean;
    /**
     * 
     * @type {number}
     * @memberof IDirContentSchema
     */
    'size': number;
    /**
     * 
     * @type {string}
     * @memberof IDirContentSchema
     */
    'last_modified': string;
}
/**
 * 
 * @export
 * @interface IGroupSchema
 */
export interface IGroupSchema {
    /**
     * 
     * @type {number}
     * @memberof IGroupSchema
     */
    'id'?: number;
    /**
     * 
     * @type {string}
     * @memberof IGroupSchema
     */
    'name': string;
}
/**
 * 
 * @export
 * @interface ILanguage
 */
export interface ILanguage {
    /**
     * 
     * @type {string}
     * @memberof ILanguage
     */
    'language_code': string;
    /**
     * 
     * @type {string}
     * @memberof ILanguage
     */
    'language': string;
}
/**
 * 
 * @export
 * @interface ILanguageCode
 */
export interface ILanguageCode {
    /**
     * 
     * @type {string}
     * @memberof ILanguageCode
     */
    'language_code': string;
}
/**
 * 
 * @export
 * @interface IPiResponseSchema
 */
export interface IPiResponseSchema {
    /**
     * 
     * @type {number}
     * @memberof IPiResponseSchema
     */
    'pi_id': number;
    /**
     * 
     * @type {string}
     * @memberof IPiResponseSchema
     */
    'ip_addr': string;
    /**
     * 
     * @type {string}
     * @memberof IPiResponseSchema
     */
    'group'?: string;
}
/**
 * 
 * @export
 * @interface IProfileSchema
 */
export interface IProfileSchema {
    /**
     * 
     * @type {number}
     * @memberof IProfileSchema
     */
    'id'?: number;
    /**
     * 
     * @type {string}
     * @memberof IProfileSchema
     */
    'preferred_language': string;
}
/**
 * 
 * @export
 * @interface IUploadResponseSchema
 */
export interface IUploadResponseSchema {
    /**
     * 
     * @type {number}
     * @memberof IUploadResponseSchema
     */
    'status_code': number;
    /**
     * 
     * @type {string}
     * @memberof IUploadResponseSchema
     */
    'message': string;
}
/**
 * 
 * @export
 * @interface IUserSchema
 */
export interface IUserSchema {
    /**
     * 
     * @type {number}
     * @memberof IUserSchema
     */
    'id'?: number;
    /**
     * Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.
     * @type {string}
     * @memberof IUserSchema
     */
    'username': string;
    /**
     * 
     * @type {string}
     * @memberof IUserSchema
     */
    'first_name'?: string;
    /**
     * 
     * @type {string}
     * @memberof IUserSchema
     */
    'last_name'?: string;
    /**
     * Designates whether the user can log into this admin site.
     * @type {boolean}
     * @memberof IUserSchema
     */
    'is_staff'?: boolean;
    /**
     * Designates whether this user should be treated as active. Unselect this instead of deleting accounts.
     * @type {boolean}
     * @memberof IUserSchema
     */
    'is_active'?: boolean;
    /**
     * Designates that this user has all permissions without explicitly assigning them.
     * @type {boolean}
     * @memberof IUserSchema
     */
    'is_superuser'?: boolean;
    /**
     * 
     * @type {Array<IGroupSchema>}
     * @memberof IUserSchema
     */
    'groups'?: Array<IGroupSchema>;
    /**
     * 
     * @type {IProfileSchema}
     * @memberof IUserSchema
     */
    'preferences'?: IProfileSchema;
}

/**
 * DefaultApi - axios parameter creator
 * @export
 */
export const DefaultApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Assign Pi To Group
         * @param {number} piId 
         * @param {string} [groupName] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiAssignPiToGroup: async (piId: number, groupName?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'piId' is not null or undefined
            assertParamExists('coreApiAssignPiToGroup', 'piId', piId)
            const localVarPath = `/api/core/pi/{pi_id}/assigngroup`
                .replace(`{${"pi_id"}}`, encodeURIComponent(String(piId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new URLSearchParams();

            // authentication SessionAuth required


            if (groupName !== undefined) { 
                localVarFormParams.set('group_name', groupName as any);
            }
    
    
            localVarHeaderParameter['Content-Type'] = 'application/x-www-form-urlencoded';
    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams.toString();

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Event Details
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiEventDetails: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/core/users`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Event Details
         * @param {number} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiEventDetails_1: async (userId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'userId' is not null or undefined
            assertParamExists('coreApiEventDetails_1', 'userId', userId)
            const localVarPath = `/api/core/users/{user_id}`
                .replace(`{${"user_id"}}`, encodeURIComponent(String(userId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Pi
         * @param {number} piId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiGetPi: async (piId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'piId' is not null or undefined
            assertParamExists('coreApiGetPi', 'piId', piId)
            const localVarPath = `/api/core/pi/{pi_id}`
                .replace(`{${"pi_id"}}`, encodeURIComponent(String(piId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication SessionAuth required


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Pis
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiGetPis: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/core/pi`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication SessionAuth required


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiLanguages: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/core/i18n/languages/`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiLanguages_2: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/core/i18n/languages/current`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Nx File Download
         * @param {string} [filePath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiNxFileDownload: async (filePath?: string, rawUrl?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/core/nextcloud/files/download`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication SessionAuth required

            if (filePath !== undefined) {
                localVarQueryParameter['file_path'] = filePath;
            }

            if (rawUrl !== undefined) {
                localVarQueryParameter['raw_url'] = rawUrl;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Nx File List
         * @param {string} [dirPath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiNxFileList: async (dirPath?: string, rawUrl?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/core/nextcloud/files/list`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (dirPath !== undefined) {
                localVarQueryParameter['dir_path'] = dirPath;
            }

            if (rawUrl !== undefined) {
                localVarQueryParameter['raw_url'] = rawUrl;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Nx File Upload
         * @param {Array<File>} files 
         * @param {string} [dirPath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiNxFileUpload: async (files: Array<File>, dirPath?: string, rawUrl?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'files' is not null or undefined
            assertParamExists('coreApiNxFileUpload', 'files', files)
            const localVarPath = `/api/core/nextcloud/files/upload`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new ((configuration && configuration.formDataCtor) || FormData)();

            // authentication SessionAuth required

            if (dirPath !== undefined) {
                localVarQueryParameter['dir_path'] = dirPath;
            }

            if (rawUrl !== undefined) {
                localVarQueryParameter['raw_url'] = rawUrl;
            }

            if (files) {
                files.forEach((element) => {
                    localVarFormParams.append('files', element as any);
                })
            }

    
    
            localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams;

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Nx User Groups
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiNxUserGroups: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/core/nextcloud/user-groups`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication SessionAuth required


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Set Language
         * @param {ILanguageCode} iLanguageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiSetLanguage: async (iLanguageCode: ILanguageCode, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'iLanguageCode' is not null or undefined
            assertParamExists('coreApiSetLanguage', 'iLanguageCode', iLanguageCode)
            const localVarPath = `/api/core/i18n/languages/`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(iLanguageCode, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DefaultApi - functional programming interface
 * @export
 */
export const DefaultApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DefaultApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Assign Pi To Group
         * @param {number} piId 
         * @param {string} [groupName] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiAssignPiToGroup(piId: number, groupName?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IPiResponseSchema>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiAssignPiToGroup(piId, groupName, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Event Details
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiEventDetails(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<IUserSchema>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiEventDetails(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Event Details
         * @param {number} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiEventDetails_1(userId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IUserSchema>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiEventDetails_1(userId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Pi
         * @param {number} piId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiGetPi(piId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IPiResponseSchema>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiGetPi(piId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Pis
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiGetPis(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<IPiResponseSchema>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiGetPis(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiLanguages(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<ILanguage>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiLanguages(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiLanguages_2(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ILanguage>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiLanguages_2(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Nx File Download
         * @param {string} [filePath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiNxFileDownload(filePath?: string, rawUrl?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiNxFileDownload(filePath, rawUrl, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Nx File List
         * @param {string} [dirPath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiNxFileList(dirPath?: string, rawUrl?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<IDirContentSchema>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiNxFileList(dirPath, rawUrl, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Nx File Upload
         * @param {Array<File>} files 
         * @param {string} [dirPath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiNxFileUpload(files: Array<File>, dirPath?: string, rawUrl?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<IUploadResponseSchema>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiNxFileUpload(files, dirPath, rawUrl, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Nx User Groups
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiNxUserGroups(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<string>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiNxUserGroups(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Set Language
         * @param {ILanguageCode} iLanguageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async coreApiSetLanguage(iLanguageCode: ILanguageCode, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.coreApiSetLanguage(iLanguageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * DefaultApi - factory interface
 * @export
 */
export const DefaultApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DefaultApiFp(configuration)
    return {
        /**
         * 
         * @summary Assign Pi To Group
         * @param {number} piId 
         * @param {string} [groupName] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiAssignPiToGroup(piId: number, groupName?: string, options?: any): AxiosPromise<IPiResponseSchema> {
            return localVarFp.coreApiAssignPiToGroup(piId, groupName, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Event Details
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiEventDetails(options?: any): AxiosPromise<Array<IUserSchema>> {
            return localVarFp.coreApiEventDetails(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Event Details
         * @param {number} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiEventDetails_1(userId: number, options?: any): AxiosPromise<IUserSchema> {
            return localVarFp.coreApiEventDetails_1(userId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Pi
         * @param {number} piId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiGetPi(piId: number, options?: any): AxiosPromise<IPiResponseSchema> {
            return localVarFp.coreApiGetPi(piId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Pis
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiGetPis(options?: any): AxiosPromise<Array<IPiResponseSchema>> {
            return localVarFp.coreApiGetPis(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiLanguages(options?: any): AxiosPromise<Array<ILanguage>> {
            return localVarFp.coreApiLanguages(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiLanguages_2(options?: any): AxiosPromise<ILanguage> {
            return localVarFp.coreApiLanguages_2(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Nx File Download
         * @param {string} [filePath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiNxFileDownload(filePath?: string, rawUrl?: boolean, options?: any): AxiosPromise<void> {
            return localVarFp.coreApiNxFileDownload(filePath, rawUrl, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Nx File List
         * @param {string} [dirPath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiNxFileList(dirPath?: string, rawUrl?: boolean, options?: any): AxiosPromise<Array<IDirContentSchema>> {
            return localVarFp.coreApiNxFileList(dirPath, rawUrl, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Nx File Upload
         * @param {Array<File>} files 
         * @param {string} [dirPath] 
         * @param {boolean} [rawUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiNxFileUpload(files: Array<File>, dirPath?: string, rawUrl?: boolean, options?: any): AxiosPromise<Array<IUploadResponseSchema>> {
            return localVarFp.coreApiNxFileUpload(files, dirPath, rawUrl, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Nx User Groups
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiNxUserGroups(options?: any): AxiosPromise<Array<string>> {
            return localVarFp.coreApiNxUserGroups(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Set Language
         * @param {ILanguageCode} iLanguageCode 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        coreApiSetLanguage(iLanguageCode: ILanguageCode, options?: any): AxiosPromise<void> {
            return localVarFp.coreApiSetLanguage(iLanguageCode, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * DefaultApi - object-oriented interface
 * @export
 * @class DefaultApi
 * @extends {BaseAPI}
 */
export class DefaultApi extends BaseAPI {
    /**
     * 
     * @summary Assign Pi To Group
     * @param {number} piId 
     * @param {string} [groupName] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiAssignPiToGroup(piId: number, groupName?: string, options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiAssignPiToGroup(piId, groupName, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Event Details
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiEventDetails(options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiEventDetails(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Event Details
     * @param {number} userId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiEventDetails_1(userId: number, options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiEventDetails_1(userId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Pi
     * @param {number} piId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiGetPi(piId: number, options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiGetPi(piId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Pis
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiGetPis(options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiGetPis(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Languages
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiLanguages(options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiLanguages(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Languages
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiLanguages_2(options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiLanguages_2(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Nx File Download
     * @param {string} [filePath] 
     * @param {boolean} [rawUrl] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiNxFileDownload(filePath?: string, rawUrl?: boolean, options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiNxFileDownload(filePath, rawUrl, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Nx File List
     * @param {string} [dirPath] 
     * @param {boolean} [rawUrl] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiNxFileList(dirPath?: string, rawUrl?: boolean, options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiNxFileList(dirPath, rawUrl, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Nx File Upload
     * @param {Array<File>} files 
     * @param {string} [dirPath] 
     * @param {boolean} [rawUrl] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiNxFileUpload(files: Array<File>, dirPath?: string, rawUrl?: boolean, options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiNxFileUpload(files, dirPath, rawUrl, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Nx User Groups
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiNxUserGroups(options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiNxUserGroups(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Set Language
     * @param {ILanguageCode} iLanguageCode 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public coreApiSetLanguage(iLanguageCode: ILanguageCode, options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).coreApiSetLanguage(iLanguageCode, options).then((request) => request(this.axios, this.basePath));
    }
}


